using System;
using System.Text.RegularExpressions;
using System.Reflection;

namespace PerformanceTest{	
class MainClass
{
	private static int IP2TEST = 400000;
	private static IpRegEx regExCom;
	private static Regex regExp;
	private static string pattern = @"^([01]?\d\d?|2[0-4]\d|25[0-5])\." + 
		@"([01]?\d\d?|2[0-4]\d|25[0-5])\.([01]?\d\d?|2[0-4]\d|25[0-5])\." +
		@"([01]?\d\d?|2[0-4]\d|25[0-5])$";
	//------------------------------------------------
	public static void Main(string[] args)
	{
	   	
		//CreateCompiledRegEx(); Raz odkomentuj
		//Klasicke STRING vyhodnocavnie
		string [] addresses =  GenerateIpAddres(IP2TEST);
	    DateTime start = DateTime.Now;
	    for(int i =0;i< IP2TEST; i++)
	    	TestIpAddr(addresses[i]);
	    
		DateTime end = DateTime.Now;
		TimeSpan rozdiel = end - start;
		Console.WriteLine("Trvanie:" + rozdiel.TotalMilliseconds);
		
		//Klasicke RegEx vyhodnocovanie
		regExp = new Regex(pattern);
		start = DateTime.Now;
	    for(int i =0;i< IP2TEST; i++)
	    	TestIpAddrRegEx(addresses[i]);
	    
		end = DateTime.Now;
	    rozdiel = end - start;
		Console.WriteLine("Trvanie:" + rozdiel.TotalMilliseconds);
		
		//Kompilovane RegEx vyhodnocavanie
		regExCom = new IpRegEx();
	    start = DateTime.Now;
	    for(int i =0;i< IP2TEST; i++)
	    	TestIpAddrRegExCom(addresses[i]);
	    
		end = DateTime.Now;
	    rozdiel = end - start;
		Console.WriteLine("Trvanie:" + rozdiel.TotalMilliseconds);
		
		Console.ReadLine();	
	}
	//------------------------------------------------
	public static void CreateCompiledRegEx()
	{
        //Tato cast, vygeneruje DLL so skompilovanym RegEx
        //+ sa zachova aj vytvorenie EXE suboru
        //lenze az po prvom spusteni, sa moze pridat ako referencia dll

	    RegexCompilationInfo rci = new RegexCompilationInfo(
        	pattern, RegexOptions.Compiled,
        	"IpRegEx", "PerformanceTest", true);
			
     	 AssemblyName an = new AssemblyName();
      	 an.Name = "IpRegEx";
      	 
      	 //Skompilovanie
      	 RegexCompilationInfo[] rciList = { rci };
      	 Regex.CompileToAssembly(rciList, an);
	}
	//------------------------------------------------
	private static string [] GenerateIpAddres(int count)
	{
		Random rnd = new Random(DateTime.Now.Second);
		string [] adresses = new string[count];
		int p1,p2,p3,p4;
		for(int i =0; i < count;  i++)
		{
			p1 = rnd.Next(400);
			p2 = rnd.Next(400);
			p3 = rnd.Next(400);
			p4 = rnd.Next(400);
			
			adresses[i]= p1.ToString()+ "."+
				p2.ToString() + "." +
				p3.ToString() +"."+
				p4.ToString();
		}    
		return adresses;    
	}
	//------------------------------------------------
	public static bool TestIpAddr(string addr)
	{
		char [] separator = new Char[]{'.'};
		string [] parts = addr.Split(separator);
		if (parts.Length!=4) return false;
		
		int onePart = 0;
		try{
		for(int i = 0; i < 4; i++)
		{
			onePart = int.Parse(parts[i]);
			if(onePart<0 || onePart>255) return false;
		}
		}catch(Exception)
		{
			return false;
		}
		return true;
	}
	//----------------------------------------------------
	public static bool TestIpAddrRegExCom(string addr)
	{
		return regExCom.IsMatch(addr);
	}
	//----------------------------------------------------
	public static bool TestIpAddrRegEx(string addr)
	{
		return  regExp.IsMatch(addr);
	}
	//----------------------------------------------------	
  }
}
